<?php

namespace Drupal\Tests\ssf\Unit;

use Drupal\Tests\UnitTestCase;
use Drupal\ssf\Degenerator;

/**
 * Tests for the Lexer.
 *
 * @coversDefaultClass \Drupal\ssf\Degenerator
 * @group ssf
 */
class LexerTest extends UnitTestCase {
  public function provideTestWords() {
    return [
      [['words' => ['WORDS', 'Words']], ['words']],
      [['words' => ['WORDS', 'Words']], ['words', 'words']],
      [['words' => ['WORDS', 'Words'], 'woRDS' => ['words', 'WORDS', 'Words']], ['words', 'woRDS']],
      [['words' => ['WORDS', 'Words'], 'sentences' => ['SENTENCES', 'Sentences']], ['words', 'sentences']],
      [['CAPITALS' => ['capitals', 'Capitals']], ['CAPITALS']],
    ];
  }

  /**
   * @dataProvider provideTestWords
   */
  public function testDegenerate($expected, $words) {
    $logger_factory = $this->createMock('\Drupal\Core\Logger\LoggerChannelFactoryInterface');
    $degenerator = new Degenerator($logger_factory);

    $this->assertArrayEquals($expected, $degenerator->degenerate($words));
  }

}